#!/usr/bin/python
import pygame
import array
import math
gb_def_freq = 22050
gb_def_size = 16
gb_def_chan = 1
gb_def_buff = 4096
gb_size_prm = {
    8   : 'B',  # unsigned 8-bit
    16  : 'H',  # unsigned 16-bit
    -8  : 'b',  # signed 8-bit
    -16 : 'h'   # signed 16-bit
}

def sinSound(freq):
    sample_per_cycle = gb_def_freq/freq
    sound = array.array(gb_size_prm[gb_def_size],[])
    step  = 2.0*math.pi/float(sample_per_cycle)
    amp   = float(1<<(abs(gb_def_size)-1))-1.0
    avg   = 0.0 if gb_def_size<0 else amp
    print "Avg %f Amp %f Step %f" % (avg,amp,step)
    for i in range(0,sample_per_cycle):
        v = int(round(avg+amp*math.sin(i*step)))
#        v = 0 if v>0 else v
        sound.append(v)
    return sound
    
print "8 %d -8 %d 16 %d -16 %d" % (pygame.AUDIO_U8, pygame.AUDIO_S8,
                                   pygame.AUDIO_U16, pygame.AUDIO_S16)

tmp_size = gb_def_size
gb_def_size = 8
pygame.mixer.init(gb_def_freq, gb_def_size, gb_def_chan)
print "Set (%d, %d, %d)" % (gb_def_freq, gb_def_size, gb_def_chan)
print "Get (%d, %d, %d)" % pygame.mixer.get_init()
pygame.mixer.quit()

gb_def_size = -8
pygame.mixer.init(gb_def_freq, gb_def_size, gb_def_chan)
print "Set (%d, %d, %d)" % (gb_def_freq, gb_def_size, gb_def_chan)
print "Get (%d, %d, %d)" % pygame.mixer.get_init()
pygame.mixer.quit()

gb_def_size = 16
pygame.mixer.init(gb_def_freq, gb_def_size, gb_def_chan)
print "Set (%d, %d, %d)" % (gb_def_freq, gb_def_size, gb_def_chan)
print "Get (%d, %d, %d)" % pygame.mixer.get_init()
pygame.mixer.quit()

gb_def_size = -16
pygame.mixer.init(gb_def_freq, gb_def_size, gb_def_chan)
print "Set (%d, %d, %d)" % (gb_def_freq, gb_def_size, gb_def_chan)
print "Get (%d, %d, %d)" % pygame.mixer.get_init()
pygame.mixer.quit()
gb_def_size = tmp_size


sound = sinSound(500)
print "Size %d Itemsize %d" % (gb_def_size, sound.itemsize)

pygame.mixer.pre_init( gb_def_freq, gb_def_size, gb_def_chan, gb_def_buff)
pygame.mixer.init(gb_def_freq, gb_def_size, gb_def_chan, gb_def_buff)
print "Set for play (%d, %d, %d)" % (gb_def_freq, gb_def_size, gb_def_chan)
print "Get for play (%d, %d, %d)" % pygame.mixer.get_init()
snd = pygame.mixer.Sound(buffer=sound)
snd.play(-1)
snd.set_volume(1.0)
print sound
raw_input("Stop?")
snd.stop()
pygame.mixer.quit()
