# -*- coding: utf-8 -*-

import pygame

pygame.init()

orig_image = pygame.Surface((200, 200))
orig_image.fill((200, 200, 200))

image = orig_image

group = pygame.sprite.LayeredUpdates()

spr1 = pygame.sprite.DirtySprite(group)
spr1.image = image
spr1.rect = image.get_rect(topleft=(11, 10))
spr2 = pygame.sprite.DirtySprite(group)
spr2.image = image
spr2.rect = image.get_rect(topleft=(209, 10))


pygame.display.set_caption("LayeredUpdate dirty rect bug")
screen = pygame.display.set_mode((800, 600))


running = True
while running:
    event = pygame.event.wait()
    if event.type == pygame.QUIT:
        running = False
    elif event.type == pygame.KEYDOWN:
        if event.key == pygame.K_ESCAPE:
            running = False

    screen.fill((255, 0, 255))
    dirty = group.draw(screen)
    print(dirty)
    pygame.display.flip()


# produces following output:

# [<rect(11, 10, 200, 200)>, <rect(0, 0, 0, 0)>, <rect(209, 10, 200, 200)>, <rect(0, 0, 0, 0)>]
# [<rect(11, 10, 200, 200)>, <rect(209, 10, 200, 200)>]
# [<rect(11, 10, 200, 200)>, <rect(209, 10, 200, 200)>]
# [<rect(11, 10, 200, 200)>, <rect(209, 10, 200, 200)>]
# [<rect(11, 10, 200, 200)>, <rect(209, 10, 200, 200)>]

