# Test bounds checking of the Surface.fill method for custom blends.

import pygame

def assertEqual(a, b):
    if a != b:
        print ("fail: %s == %s" % (a, b))

def assertNotEqual(a, b):
    if a == b:
        print ("fail: %s != %s" % (a, b))

black = pygame.Color("black")
red = pygame.Color("red")
assertNotEqual(black, red)

surf = pygame.Surface((10, 10), 0, 32)
surf.fill(black)
subsurf = surf.subsurface(pygame.Rect(0, 1, 10, 8))
assertEqual(surf.get_at((0, 0)), black)
assertEqual(surf.get_at((0, 9)), black)
subsurf.fill(red, (0, -1, 10, 1), pygame.BLEND_RGB_ADD)
assertEqual(surf.get_at((0, 0)), black)
assertEqual(surf.get_at((0, 9)), black)
subsurf.fill(red, (0, 8, 10, 1), pygame.BLEND_RGB_ADD)
assertEqual(surf.get_at((0, 0)), black)
assertEqual(surf.get_at((0, 9)), black)
